function base_detail_separation(input_gray,sigma_s,sigma_r,base,detail,...
                       grain1,size1,grain2,size2,grain3,size3,grain4,size4)

sigma_s     = str2double(sigma_s);
sigma_r     = str2double(sigma_r);
size1       = str2double(size1);
size2       = str2double(size2);
size3       = str2double(size3);
size4       = str2double(size4);

input       = imread(input_gray);
input       = double(input);

grain1      = double(imread(grain1));
grain2      = double(imread(grain2));
grain3      = double(imread(grain3));
grain4      = double(imread(grain4));

weightfunspace = @(A)(exp( -A   /(2*sigma_s^2)));
weightfunrange = @(u)(exp( -u.^2/(2*sigma_r^2)));

Idet1 = (input  - grain1);
Idet2 = (grain1 - grain2);
Idet3 = (grain2 - grain3);
Idet4 = (grain3 - grain4);

Idet  = Idet1*weightfunspace(size1).*weightfunrange(Idet1) ...
      + Idet2*weightfunspace(size2).*weightfunrange(Idet2) ...
      + Idet3*weightfunspace(size3).*weightfunrange(Idet3) ...
      + Idet4*weightfunspace(size4).*weightfunrange(Idet4) ;

Ibase = input - Idet;

imwrite(uint8(Ibase),base);
imwrite(uint8(128 + 10*Idet ),detail);

end